package de.uni_passau.fim.seibt.gitwrapper.repo;

import java.io.File;
import java.util.Collections;
import java.util.Map;

public class BlameLine {

    public final Commit commit;

    public final int originalLineNumber;
    public final int finalLineNumber;

    public final File file;
    public final String line;

    public final Map<String, String> otherHeaderFields;

    private BlameLine(Commit commit, int originalLineNumber, int finalLineNumber, File file, String line,
                      Map<String, String> otherHeaderFields) {

        this.commit = commit;
        this.originalLineNumber = originalLineNumber;
        this.finalLineNumber = finalLineNumber;
        this.file = file;
        this.line = line;
        this.otherHeaderFields = otherHeaderFields;
    }

    static BlameLine firstOccurrence(Commit commit, int originalLineNumber, int finalLineNumber, File file, String line,
                                     Map<String, String> otherHeaderFields) {

        Map<String, String> other = otherHeaderFields.isEmpty() ? Collections.EMPTY_MAP : Collections.unmodifiableMap(otherHeaderFields);
        return new BlameLine(commit, originalLineNumber, finalLineNumber, file, line, other);
    }

    static BlameLine nextOccurrence(BlameLine firstOccurrence, int originalLineNumber, int finalLineNumber,
                                    String line) {

        return new BlameLine(firstOccurrence.commit, originalLineNumber, finalLineNumber, firstOccurrence.file, line, firstOccurrence.otherHeaderFields);
    }
}
